#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	SPIRV-LLVM-Translator
Version		:	19.1.0
Release		:	17.2.0.rel%{?dist}
Summary		:	LLVM to SPIRV Translator

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	NCSA
URL		:	https://github.com/KhronosGroup/%{name}

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	llvm-devel
BuildRequires	:	ninja
BuildRequires	:	SPIRV-Headers-devel
BuildRequires	:	SPIRV-Tools-devel

#-----------------------------------------------------------------------------
%description
Khronos LLVM to SPIRV Translator. This is a library
to be used by Mesa for OpenCL support. It translate
LLVM IR to Khronos SPIR-V. It also includes a
standalone tool used for building libclc.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%doc README.md
%{_libdir}/libLLVMSPIRVLib.so.19*

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and
header files for developing applications that
use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/LLVMSPIRVLib/LLVMSPIRVExtensions.inc
%{_includedir}/LLVMSPIRVLib/*.h
%{_libdir}/libLLVMSPIRVLib.so
%{_libdir}/pkgconfig/LLVMSPIRVLib.pc

#=============================================================================
%package		tools
Summary		:	Standalone llvm to spirv translator tool

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		tools
This package contains the standalone llvm to spirv tool.

#-----------------------------------------------------------------------------
%files			tools
%defattr(-,root,root,-)
%{_bindir}/llvm-spirv

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-B _bld						\
	-G 'Unix Makefiles'				\
	-S .						\
	-D BUILD_SHARED_LIBS=ON				\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_BINDIR=%{_bindir}		\
	-D CMAKE_INSTALL_LIBDIR=%{_libdir}		\
	-D CMAKE_POSITION_INDEPENDENT_CODE=ON		\
	-D CMAKE_SKIP_RPATH=ON 				\
	-D LLVM_BUILD_TOOLS=ON				\
	-D LLVM_INCLUDE_TESTS=ON			\
	-D LLVM_DIR="%{_libdir}/cmake/llvm/"		\
	-D LLVM_LIBDIR_SUFFIX= 				\
	-D LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=%{_sysconfdir}/spirv/


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
cmake							\
	--build						\
	_bld						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
LD_LIBRARY_PATH="./_bld/lib/SPIRV"			\
	ctest						\
		--test-dir _bld				\
	 	--output-on-failure

#-----------------------------------------------------------------------------
#installing program
%install

%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install					\
	_bld

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
